﻿using System.Collections.ObjectModel;
using System.Windows;

namespace XamDataTreeCrash
{
    public partial class MainPage
    {  
        public class MyData
        {
            public string ID { get; set; }
            public string ParentID { get; set; }
            public string Caption { get; set; }
            public ObservableCollection<MyData> Children { get; set; }
        }

        public MainPage()
        {
            InitializeComponent();
            Loaded += MainPage_Loaded;
        }
        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            //Add root
            var data = new ObservableCollection<MyData>
                           {
                                new MyData { ID = "root", Caption = "Root node", Children = new ObservableCollection<MyData>() }
                           };

            // -------------------------------
            // Steps to reproduce the component crash:
            // -------------------------------
            // 1. Start application
            // 2. Open/Close the Root node in the treeview a few times..(if you can ;) )
            // >>> CRASH !!
            // -------------------------------
            // >>> "Layout cycle detected.  Layout could not complete"  WTH is going on ....!!"#¤"!#¤"
            // -------------------------------


            // -------------------------------
            // When testing there is a magic number of 371 which seems to be the limit. 370 is ok, 371 crashes.
            // -------------------------------
            const int numOfNodes = 371;
            // -------------------------------

            // Create test data nodes
            for (int i = 0; i < numOfNodes; i++)
                data[0].Children.Add(new MyData { ID = i.ToString(), ParentID = "root", Caption = "Node: " + i });

            // Bind data
            myDataTree.ItemsSource = data;

        }
    }
}
